/***** BEGIN LICENSE BLOCK *****
   - Version: MPL 1.1/GPL 2.0/LGPL 2.1
   -
   - The contents of this file are subject to the Mozilla Public License Version
   - 1.1 (the "License"); you may not use this file except in compliance with
   - the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License.
   -
   - The Original Code is the Jump Link.
   -
   - The Initial Developer of the Original Code is Philip Mateescu.
   - Portions created by the Initial Developer are Copyright (C) 2002-2003
   - the Initial Developer. All Rights Reserved.
   -
   - Contributor(s): Philip Mateescu <xbiker @ yahoo.com>
   -
   - Alternatively, the contents of this file may be used under the terms of
   - either the GNU General Public License Version 2 or later (the "GPL"), or
   - the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   - in which case the provisions of the GPL or the LGPL are applicable instead
   - of those above. If you wish to allow use of your version of this file only
   - under the terms of either the GPL or the LGPL, and not to allow others to
   - use your version of this file under the terms of the MPL, indicate your
   - decision by deleting the provisions above and replace them with the notice
   - and other provisions required by the LGPL or the GPL. If you do not delete
   - the provisions above, a recipient may use your version of this file under
   - the terms of any one of the MPL, the GPL or the LGPL.
   -
   - ***** END LICENSE BLOCK *****/

var jumpMenuItems = new Array("jumplink-sep", "jump-in-current", 'jump-in-new-window', 'jump-in-new-tab');

function jumpContext() {
	if(gContextMenu) {
		if(!("getLinkURL" in gContextMenu))
			gContextMenu.getLinkURL = gContextMenu.linkURL;
		show = (gContextMenu.onLink && (fetchLink()));
		for(var i=0; i<jumpMenuItems.length; i++) {
			var menuitem = document.getElementById(jumpMenuItems[i]);
			if(menuitem)
				menuitem.hidden = !show;
		}
	}
}



function isJumperLink(link) {
	//~ var re = /\S\/.*((?:http|ftp|https)(?:[:]|%3a).+)/gi;
	/// contributted by Fuiru - it should stop parsing when & are encountered
	/// to avoid http://foo/go?url=http://bar/zoom%zzsource=foo%zzgo=blah&click=1
	/// in the above case, the click=1 is not part of the URL. it it were, it should've
	/// been escaped.
	/// the %253a comes from double escaping the URL (as in escape(escape(URL)))
	var re = new RegExp("\\S\\/.*((?:http|ftp|https)(?:[:]|%3a|%253a)[^&]+)", "gi");
	re.compile("\\S\\/.*((?:http|ftp|https)(?:[:]|%3a|%253a)[^&]+)", "gi");
	if((r = link.match(re))) {
		var ret = RegExp.$1;
		if (ret.indexOf('%253a')) {
			/// string is in 5t00p1d Hotmail double escape choco-latte format
			if (link.toLowerCase().indexOf('javascript') == 0) {
				// it starts with javascript, then we only need to capture what is a valid URL
				if (ret.match(/(.+?)[^-%a-z0-9:\/&]+$/gi)) {
					return unescape(RegExp.$1);
				} else {
					return ret; // don't know what to do with it
				}
				
			}
			return unescape(ret);
		} else {
			return ret;
		}
	}
	
	/// doing tips and trick with the best of them :)
	/// Hotmail has decided that the only possible way they could increase their SUCK rating
	/// is to use javascript:OpenWin('http..._-action=http..') links instead.
	/// so we will work around that.
	if (link.toLowerCase().indexOf('javascript') == 0) {
		// hah! i gotcha
		link2 = link.substr(link.indexOf('http'));
		WScript.Echo(link2);
		if((r = link2.match(re))) {
			// if the string contains %253a we have to unescape it before we send it out
			var ret = RegExp.$1;
			if (ret.indexOf('%253a')) {
				/// string is in 5t00p1d Hotmail double escape choco-latte format
				return unescape(ret);
			} else {
				return ret;
			}
		}
	}
	return null;
}




function fetchLink() {
	if((r = isJumperLink(gContextMenu.getLinkURL()))) {
		return unescape(r);
	} else {
		return null;
	}
}


function getCurrentBrowser() {
	var latestBrowser = null;
	var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
							   .getService(Components.interfaces.nsIWindowMediator);
	var browserWindow = windowMediator.getMostRecentWindow("navigator:browser");

	if (browserWindow) {
		latestBrowser = browserWindow.getBrowser();
	}
	return latestBrowser;
}

function jumpSelectionInCurrent() {
	if((L = fetchLink())) {
		getCurrentBrowser().loadURI(L);
	}
}
function jumpSelectionInNewWindow () {
	if((L = fetchLink())) {
		openNewWindowWith(L, false);
	}
}

function jumpSelectionInNewTab(e) {
	if((L = fetchLink())) {
		var theBrowser = getCurrentBrowser();
		var tab = theBrowser.addTab(L, null);
	
		var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		if (pref) {
			var loadInBackground = pref.getBoolPref("browser.tabs.loadInBackground");
			if (e && e.shiftKey) {
				loadInBackground = !loadInBackground;
			}
			if (!loadInBackground) {
				theBrowser.selectedTab = tab;
			}
		}
	}
}


function init() {
    var menu = document.getElementById("contentAreaContextMenu");
    menu.addEventListener("popupshowing", jumpContext, false);
}

window.addEventListener("load", init, false);


/*
var link = "javascript:OpenWin('http://64.4.43.250/cgi-bin/linkrd?_lang=EN&lah=f1cf35bcf8e8eff52f3f0dcc0f806e80&lat=1097204883&hm___action=http%253a%252f%252fzones%252echtah%252ecom%252fa%252fhBBZZEIAQU9a0ARmQjtAKetp04O%252fitzn13');"
var link = "http://64.4.43.250/cgi-bin/linkrd?_lang=EN&lah=f1cf35bcf8e8eff52f3f0dcc0f806e80&lat=1097204883&hm___action=http%253a%252f%252fzones%252echtah%252ecom%252fa%252fhBBZZEIAQU9a0ARmQjtAKetp04O%252fitzn13"
var link = "http://64.4.43.250/cgi-bin/linkrd?_lang=EN&hm___action=http%3a%2f%2fwww%2eebay%2ecom";
WScript.Echo(unescape('http%253a%252f%252fzones%252echtah%252ecom%252fa%252fhBBZZEIAQU9a0ARmQjtAKetp04O%252fitzn13'))
WScript.Echo(isJumperLink(link));
*/